AppTitle "One-Button Bloodbath" 

; Copyright (c) 2004, Joe Lesko


Graphics 640, 480, 16, 1

SeedRnd(MilliSecs())

PlayMusic("sounds\commando.mod")

Include "images.bb"
Include "objects\o_game.bb"
Include "objects\o_stage.bb"
Include "objects\o_wave.bb"
Include "objects\o_bullet_hole.bb"
Include "objects\o_corpse.bb"
Include "objects\o_explosion.bb"
Include "objects\o_shell.bb"
Include "objects\o_grenade.bb"
Include "objects\o_hero.bb"
Include "objects\o_enemy.bb"
Include "objects\o_enemy_score.bb"
Include "objects\o_scorch_mark.bb"
Include "objects\o_message.bb"
Include "objects\o_weapon_queue.bb"
Include "objects\o_machine_gun.bb"
Include "objects\o_plant.bb"
Include "objects\o_helicopter.bb"


;=========================== MUSIC ===================================


Dim MUSIC$(3)
MUSIC$(0) = "music\dreamfish_sanxion.mod"
MUSIC$(1) = "music\nashua_bulldog.xm"
MUSIC$(2) = "music\instantremedy_gianasisters.xm"

Dim MUSIC_VOLUME#(3)
MUSIC_VOLUME#(0) = 0.15
MUSIC_VOLUME#(1) = 0.25
MUSIC_VOLUME#(2) = 0.3

Global END_MUSIC$ = "music\commando_high.mid"
Global MUSIC_MAIN
Global TRACK_NUM = Rand(0,2)

Global MUSIC_END


;=========================== FONTS ===================================

Global FONT_VERY_LARGE = LoadFont("Arial Black", 32, 1, 0, 0)
Global FONT_LARGE      = LoadFont("Arial Black", 24, 0, 0, 0)
Global FONT_SMALL      = LoadFont("Arial Black", 16, 0, 0, 0)



;=========================== SOUNDS ===================================

Global SND_SHOTGUN     = LoadSound("sounds\wpn_shotgun.wav")
Global SND_MACHINE_GUN = LoadSound("sounds\wpn_machinegun.wav")
Global SND_EXPLOSION   = LoadSound("sounds\explosion.wav")

Global SND_SUB_MACHINE_GUN1 = LoadSound("sounds\wpn_smg1.wav")
Global SND_SUB_MACHINE_GUN2 = LoadSound("sounds\wpn_smg2.wav")

Global SND_RICOCHET1 = LoadSound("sounds\ricochet1.wav")
Global SND_RICOCHET2 = LoadSound("sounds\ricochet2.wav")

Global SND_WILHELM = LoadSound("sounds\wilhelm.wav")

Global SND_HELICOPTER = LoadSound("sounds\helicopter.wav")
Global SND_CLICK = LoadSound("sounds\click.mp3")


;========================= CONFIG ======================================

Const HIT_SCORE = 10
Const PERFECT_MULTIPLIER = 5
Const GRENADE_SPEED_Y# = 6.0
Const MACHINE_GUN_SPEED_Y# = 6.0
Const EXPLOSION_TIMER = 14

Const GRENADE_EXPLOSION_DIAMETER = 40

Const MAX_CORPSE_FRAME = 3

Global TIMER = CreateTimer(40)

Const STATE_MAIN_MENU = 0
Const STATE_IN_GAME   = 1

Const WEAPON_SHOTGUN     = 0
Const WEAPON_MACHINE_GUN = 1
Const WEAPON_GRENADE     = 2

Const KEY_SPACE = 57
Const KEY_EQUALS = 13



;========================= MAIN ======================================



Global STAGE.Stage
Global WAVE.Wave
Global HERO.Hero
Global GAME.Game

Global SCREEN_SHOT_NUM = 0


.StartGame

Main()




Function Main ()
    
    playGame = MainScreen()
    
    If playGame = True 
        
        GAME.Game   = NewGame()
        HERO.Hero   = NewHero()
        STAGE.Stage = NewStage(GAME\stage, HERO)
        WAVE.Wave   = NewWave(STAGE\wave)
        WAVE\firstShot = True
        WAVE\introTimer = 70
        
        NewWeaponQueue()
        
        NewMessage("Let the Carnage Begin!", "", 60)
        
        PlayNextTrack()     
       
        While Not KeyHit(1)
    
            
            Update()
            Render()
                
            ; Cleared Wave
            If WAVE\numEnemies = 0
                
                Delete WAVE
                
                GAME\totalWaves = GAME\totalWaves + 1
                
                If GAME\totalWaves = 136
                
                    Goto EndScreen
                
                Else
                               
                    STAGE\wave = STAGE\wave + 1
                    If STAGE\wave = 28
                        
                        GAME\stage = GAME\stage + 1
                        STAGE.Stage = NewStage(GAME\stage, HERO)
                        
                        STAGE\wave = 1
                    
                    End If
                    
                    WAVE.Wave = NewWave(STAGE\wave)
                    NewWeaponQueue()
                    
                End If 
                
            End If
        
            
        
        Wend 

        .EndScreen
        EndScreen()

    End If  ; playGame

    .EndGame

End Function



;========================= FUNCTIONS ======================================



Function Update ()

    WaitTimer(TIMER)
    GAME\frame = GAME\frame + 1

    If ChannelPlaying(MUSIC_MAIN) = False Then PlayNextTrack()

    If KeyHit(KEY_SPACE) = True And WAVE\introTimer = 0
    
        If HERO\weapon = WEAPON_SHOTGUN And HERO\shotgunTimer = 0

            ; Fire Shotgun
            pan# = (-320.0 + HERO\posX#) / 640.0
            SoundPan(SND_SHOTGUN, pan#)        
            SoundVolume SND_SHOTGUN, Rnd(0.7,0.9)   
            PlaySound(SND_SHOTGUN)
                
            s.Shell = New Shell
            s\posX# = HERO\posX#
            s\posY# = HERO\posY#
            s\speedY# = -20.0
                
            HERO\shotgunTimer = 30
            
        Else If HERO\weapon = WEAPON_MACHINE_GUN And HERO\machineGunTimer = 0

            ; Fire Machine Gun
            pan# = (-320.0 + HERO\posX#) / 640.0
            SoundPan(SND_MACHINE_GUN, pan#)         
            SoundVolume SND_MACHINE_GUN, Rnd(0.4, 0.6)
            SoundPitch(SND_MACHINE_GUN, 10500 + (Rand(1,3) * 250))
            PlaySound(SND_MACHINE_GUN)
            
            HERO\machineGunTargetY# = HERO\posY# - 100.0            
            HERO\machineGunKills = 0           
            HERO\machineGunTimer = 45
           
        Else If HERO\weapon = WEAPON_GRENADE And HERO\grenadeTossed = True 
        
            ; Grenade Explodes
            pan# = (-320.0 + HERO\posX#) / 640.0
            SoundPan(SND_EXPLOSION, pan#)   
            PlaySound(SND_EXPLOSION)
                        
            NewExplosion(HERO\grenadeX#, HERO\grenadeY# - 48)    
            NewScorchMark(HERO\grenadeX#, HERO\grenadeY#)             
            CollisionExplosion()
            GAME\shakeTimer = 4
        
            HERO\grenadeTossed = False
            
            UpdateWeaponQueue()

        Else If HERO\weapon = WEAPON_GRENADE
        
            ; Throw Grenade
            HERO\grenadeX# = HERO\posX#
            HERO\grenadeY# = HERO\posY# - 40.0
            HERO\grenadeSpeedY# = GRENADE_SPEED_Y# + Rand(-0.5,0.5)           
            HERO\grenadeTossed = True
        
        End If

    End If

    

    If WAVE\introTimer > 0 Then WAVE\introTimer = WAVE\introTimer - 1

    If HERO\machineGunTimer > 0  Then UpdateMachineGun()
    If HERO\grenadeTossed = True Then UpdateGrenade()
    
    UpdateExplosions()
    UpdateShotgunShells()
    
    If WAVE\introTimer = 0 Then UpdateEnemies()
    UpdateEnemyScores()
    UpdateScorchMarks()
    
    
    UpdateMessage()
    UpdateHelicopters()
   
    If GAME\shakeTimer > 0 Then GAME\shakeTimer = GAME\shakeTimer - 1
    
    If GAME\frame Mod 60 = 0
        NewPlant(1) : NewPlant(-1)
    End If
    
    ; Stop walking when grenade is tossed
    If HERO\grenadeTossed = False 
    
        UpdateHero()
        UpdateBackground()
        UpdateCorpses()
        UpdatePlants()
    
    End If
    
    ; Screenshot
    If KeyDown(KEY_EQUALS) = True Then SaveScreen()
   
End Function



Function SoundPanPosX (snd, posX#)

    pan# = (-320.0 + posX#) / 640.0        
    SoundPan(snd, pan#)

End Function



Function PlaySoundWilhelm (posX#)

    SoundPanPosX(SND_WILHELM, posX#) 
    SoundPitch(SND_WILHELM, 11000 + (Rand(-2,2) * 500))       
    SoundVolume(SND_WILHELM, Rnd(0.1,0.15))
        
    PlaySound(SND_WILHELM)     

End Function



Function ResetKillStreak ()
    
    If GAME\killStreak > GAME\hiKillStreak Then GAME\hiKillStreak = GAME\killStreak
    GAME\killStreak = 0   

    RegisterMiss()

End Function



Function RegisterKill (e.Enemy)

    WAVE\consecMisses = 0

    WAVE\numEnemies = WAVE\numEnemies - 1
    
    killScore = (HIT_SCORE * (GAME\killStreak + 1))
    
    If WAVE\isTriple = True Then killScore = killScore * 3
    If e\isCommando  = True Then killScore = killScore * 2
    If e\isBoss      = True Then killScore = killScore * 10
    
    GAME\score = GAME\score + killScore
    
    GAME\totalKills = GAME\totalKills + 1
    GAME\killStreak = GAME\killStreak + 1

    Return killScore

End Function



Function RegisterMiss ()

    WAVE\consecMisses = WAVE\consecMisses + 1
    pen = 0
    Select WAVE\consecMisses
        Case 1  : pen = 10
        Case 2  : pen = 25
        Case 3  : pen = 50
        Default : pen = 100
    End Select

    GAME\score = GAME\score - pen
    If GAME\score < 0 Then GAME\score = 0

    NewMessage("Miss Penalty: " + pen + " pts", "", 30)

End Function



Function UpdateBackground ()

    STAGE\bkgPosY# = STAGE\bkgPosY# + STAGE\speedY#
    UpdateBulletHoles()

End Function 




Function Render ()
    
    SetBuffer BackBuffer()
    
    If GAME\shakeTimer > 0 Then Origin Rand(-2,2), Rand(-1,1)
    
    TileImage(IMG_BACKGROUND, 0.0, STAGE\bkgPosY#)
    
    RenderScorchMarks()
    RenderCorpses()  
    RenderBulletHoles() 
    RenderExplosions() 
    RenderShotgunShells()
    RenderHero()
    RenderEnemies()   
    RenderPlants()
    RenderHelicopters()
    
    If HERO\grenadeTossed = True Then RenderGrenade() 

    RenderMachineGun()

    RenderWeaponQueue()
    If WAVE\isTriple = True
        SetFont FONT_SMALL
        Color 216,0,0
        Text 316, 430, "Triple Multiplier!", True 
    End If

    RenderEnemyScores()


    SetFont FONT_LARGE
    Color 255,255,255
    Text 10,450, "Score: " + GAME\score
    Text 470,450, "Wave: " + GAME\totalWaves + " of 135"
    Text 455,10, "Kills: " + GAME\totalKills + " of 1000"

    SetFont FONT_SMALL
    Text 10, 10, "Hi Streak: "
    Text 27, 25, "Streak: "
    
    Color 216,0,0
    endX = RenderKillStreak(76, 13, GAME\hiKillStreak)
    If GAME\hiKillStreak > 0 Then Text endX + 8, 10, "= " + GAME\hiKillStreak
    
    Color 0,0,0
    RenderKillStreak(76, 28, GAME\killStreak)

    RenderMessage()

    Flip

End Function



Function SaveScreen ()

    SCREEN_SHOT_NUM = SCREEN_SHOT_NUM + 1
    file$ = "screenshot" + SCREEN_SHOT_NUM + ".bmp"
    SaveBuffer(FrontBuffer(), file$)

End Function



Function RenderKillStreak (baseX, baseY, numTicks)

    tickHt = 9
    endX = baseX

    For i = 1 To numTicks
    
        chunk = i / 5
        
        If i Mod 5 = 0       
            ; diagonal 5th tick
            tickX = baseX + ((chunk - 1) * 14)
            Line tickX, baseY + tickHt - 1, tickX + 10, baseY + 1
            endX = tickX + 10     
        Else
            l = i Mod 5
            tickX = baseX + (chunk * 14) + (l * 2)
            Line tickX, baseY, tickX, baseY + tickHt
            endX = tickX
        End If
    
    Next

    Return endX

End Function



Function EndScreen ()

    StopChannel(MUSIC_MAIN)
    SoundVolume(SND_CLICK, 0.05)

    MUSIC_END = PlayMusic(END_MUSIC$)
    ChannelVolume(MUSIC_END, .5)

    FlushKeys()

   
    ; Create shade image
    shade = CreateImage(320,240)
    SetBuffer(ImageBuffer(shade))
    Color 16,0,0
    For x = 1 To 320
        For y = 1 To 240 
            If (x + y) Mod 2 = 1 Then Plot x, y
        Next
    Next    
    Rect 0, 0, 320, 240, False
    


    currKills = 0
    
    While Not KeyHit(1)
    
        GAME\frame = GAME\frame + 1
        If currKills < GAME\totalKills
            currKills = currKills + 1
            e.Enemy = New Enemy
            e\posX# = Rnd(0.0, 640.0)
            e\posY# = Rnd(0.0, 480.0)
            If currKills Mod 200 = 0
                e\isBoss = True
            Else If Rand(5) = 1
                e\isCommando = True 
            End If
            
            NewCorpse(e)
            Delete e
            PlaySound(SND_CLICK)
        End If
    
    
        SetBuffer BackBuffer()
        
        ClsColor 168,0,0
        Cls

        RenderCorpses()
        
        DrawImage(shade, 160, 120)
        
        
        If GAME\totalKills = 1000

            SetFont FONT_VERY_LARGE
            DropText(320,140, "CONGRATULATIONS!")
            
            SetFont FONT_SMALL
            DropText(320,170, "The President awards you The Golden Machine Gun!")
            
            DrawImage(IMG_TROPHY, 180, 280)

        Else If GAME\totalKills > 800
        
            SetFont FONT_VERY_LARGE
            DropText(320,140, "AWESOME JOB!")
            
            SetFont FONT_SMALL
            DropText(320,170, "You're a one-man devastation machine!")
            
            DrawImage(IMG_RIBBON, 180, 280)        
        
        
        Else If GAME\totalKills > 600
        
            SetFont FONT_VERY_LARGE
            DropText(320,140, "GREAT JOB!")
            
            SetFont FONT_SMALL
            DropText(320,170, "Destruction is second nature to you!")
            
            DrawImage(IMG_RIBBON, 180, 280)        
        
        Else If GAME\totalKills > 400
        
            SetFont FONT_VERY_LARGE
            DropText(320,140, "GOOD JOB!")
            
            SetFont FONT_SMALL
            DropText(320,170, "Try to go for 1000 kills next time!")
           

        Else If GAME\totalKills > 200
        
            SetFont FONT_VERY_LARGE
            DropText(320,140, "NOT TOO SHABBY!")
            
            SetFont FONT_SMALL
            DropText(320,170, "But I've seen higher body counts.")
            

        Else If GAME\totalKills > 1
        
            SetFont FONT_VERY_LARGE
            DropText(320,140, "NICE TRY!")
            
            SetFont FONT_SMALL
            DropText(320,170, "You can (and must) do better next time!")
        
        Else 
        
            SetFont FONT_VERY_LARGE
            DropText(320,140, "TERRIBLE JOB!")
            
            SetFont FONT_SMALL
            DropText(320,170, "You have been kicked out of the army!")
        
        End If

        Color 255,255,255
        SetFont FONT_LARGE
        
        DropText(320,200, "Score: " + GAME\score)
        DropText(320,240, "High Streak: " + GAME\hiKillStreak)
        DropText(320,280, "Total Kills: " + currKills)

        If currKills = GAME\totalKills
            SetFont FONT_SMALL
            DropText(320, 320, "Press ESC to Leave Game")
        End If

        Flip
        
    Wend

End Function


Function DropText (posX, posY, msg$)

    Color 64,0,0
    Text posX - 1, posY + 1, msg$, True
    Color 255,255,255
    Text posX, posY, msg$, True

End Function



Function MainScreen ()

    FlushKeys()

    SetBuffer BackBuffer()
    ClsColor 0,0,0
    Cls

    DrawBlock(IMG_MAIN, 0, 0)

    Color 255,255,255
    SetFont FONT_LARGE
    Text 320, 210, "Press SPACE to Begin", True
    
    SetFont FONT_SMALL
    Text 320, 270, "Game ends when you hit ESC key", true
    Text 320, 290, "... or kill the 1000th Enemy!", True

    Color 216,216,0
    Text 560, 450, "Version 0.5"
    Text 20, 450, "(C) 2004, Joe Lesko"

    Flip

    While Not KeyHit(1)
    
        If KeyHit(KEY_SPACE) Then Return 1
    
    Wend

    Return 0

End Function



Function PlayNextTrack ()

    StopChannel MUSIC_MAIN

    TRACK_NUM = TRACK_NUM + 1
    If TRACK_NUM = 3 Then TRACK_NUM = 0
    
    MUSIC_MAIN = PlayMusic(MUSIC$(TRACK_NUM))
    ChannelVolume MUSIC_MAIN, MUSIC_VOLUME#(TRACK_NUM)

    Return chan

End Function