
Type Enemy

    Field frame
    Field posX#
    Field posY#
    Field speedX#
    Field speedY#
    Field isCommando
    Field isBoss    
    Field fireFrame
    Field runFrame
    Field animOffset
    Field fireTimer
    Field runTimer
    Field aimTimer
    
End Type

Dim enemyZ.Enemy (100)




Function NewEnemy.Enemy (commandoNum = 0, isBoss = False)

    e.Enemy = New Enemy

    If commandoNum > 0
        e\isCommando = True
        
        e\speedX# = Rnd(-6.0, -4.0)
        
        If commandoNum Mod 2 = 0 Then e\posX# = 720 + Rand(100)
        If commandoNum Mod 2 = 1 Then e\posX# = -40 - Rand(100) : e\speedX# = -1.0 * e\speedX#
        
        e\posY#   = 60 + (commandoNum * 20)
        
        e\speedY# = 0.0 
    Else If isBoss = True
        e\isBoss = True 
        e\posX#   = 780
        e\posY#   = 60
        e\speedX# = -7.5 - (0.5 * GAME\stage)
        e\speedY# = 0.0           
    Else
        e\posX#   = Rnd(120.0, 520.0)
        e\posY#   = -40.0 + Rnd(-50.0, 20.0)
        e\speedX# = (-1 ^ Rand(2)) * Rnd(2.0, 4.0)
        e\speedY# = (-1 ^ Rand(2)) * Rnd(1.0, 2.0)        
    End If 

    e\frame   = 0

    e\animOffset = Rand(0,6)
    e\runTimer = 50 + Rand(200)

    Return e

End Function



Function UpdateEnemies ()

    For e.Enemy = Each Enemy

        ; Animation
        If GAME\frame Mod 10 = e\animOffset Then e\runFrame = 1 - e\runFrame
        
        ; Running
        If e\runTimer > 0
        
            e\frame = e\runFrame
            
            e\runTimer = e\runTimer - 1               
            If e\runTimer = 0                   
                e\aimTimer = 30 + Rand(30)                    
            End If
        End If 

        
        If e\posY# < 50.0
        
            e\posY# = e\posY# + 1.5
            
        Else 
            
            e\posX# = e\posX# + e\speedX#
            e\posY# = e\posY# + e\speedY#  
            
            ; Boundaries            
            If e\speedX# > 0.0                
                If ( e\posX# >= 520.0)
                    e\speedX# = -1.0 * e\speedX#  
                End If            
            Else
                If (e\posX# <= 120.0 )
                    e\speedX# = -1.0 * e\speedX#  
                End If                        
            End If


            If (e\posY# < 50.0 Or e\posY# > 250.0)
                e\speedY# = -1.0 * e\speedY#
            End If
            
                     

            ; Animation  
            ; Aiming
            If e\aimTimer > 0
                
                e\frame = e\runFrame + 2
                
                e\aimTimer = e\aimTimer - 1
                If e\aimTimer = 0
                    
                    If Rand(2) = 1
                        fireSound = SND_SUB_MACHINE_GUN1
                        e\fireTimer = 30  
                    Else
                        fireSound = SND_SUB_MACHINE_GUN2
                        e\fireTimer = 24
                    End If              
                    
                    SoundPanPosX(fireSound, e\posX#)
                    SoundPitch(fireSound, 11000 + (Rand(-2,2) * 250))
                    SoundVolume(fireSound, Rnd(0.1,0.25))        
                    PlaySound(fireSound)
                    
                End If
                
            ; Firing
            Else If e\fireTimer > 0
                
                If e\fireTimer Mod 3 = 0
                    e\fireFrame = 1 - e\fireFrame
                End If
                
                e\frame = e\runFrame + 4 + (e\fireFrame * 2)
                
                e\fireTimer = e\fireTimer - 1                               
                If e\fireTimer = 0
                    
                    ; ricochet    
                    If Rand(1,3) = 1
                        
                        ric = SND_RICOCHET1
                        If Rand(1,2) = 1 Then ric = SND_RICOCHET2
                        
                        SoundPanPosX(ric, HERO\posX#)
                        SoundPitch(ric, 11000 + (Rand(-2,2) * 500))
                        SoundVolume(ric, Rnd(0.2, 0.3))
                                                    
                        PlaySound(ric)
                        
                    End If
                    
                    e\runTimer = Rand(100,200) 
                
                End If
                              
            End If            
                        
        End If
    
        If WAVE\numEnemies = 1 And WAVE\onLastEnemy = False And WAVE\isBoss = False 
            WAVE\onLastEnemy = True
            e\speedX# = (-1 ^ Rand(2)) * Rnd(5.0,7.0)
            e\speedY# = (-1 ^ Rand(2)) * Rnd(1.0,2.0)
        End If

    Next

End Function




Function RenderEnemies ()
    
    numEnemies = 0
    For e.Enemy = Each Enemy
        numEnemies = numEnemies + 1
        enemyZ(numEnemies) = e       
    Next     

    For i = 1 To numEnemies
        hiEnemy = i
        For j = i To numEnemies
            If (enemyZ(j)\posY# < enemyZ(hiEnemy)\posY#)
                hiEnemy = j
            End If
        Next
        swap.Enemy = enemyZ(i)
        enemyZ(i) = enemyZ(hiEnemy)
        enemyZ(hiEnemy) = swap.Enemy
    Next     

    For i = 1 To numEnemies 
                        
        DrawImage(IMG_SHADOW, Floor(enemyZ(i)\posX#), Floor(enemyZ(i)\posY# + 35.0))
        
        If enemyZ(i)\isCommando = True 
            DrawImage(IMG_ENEMY_COMMANDO, Floor(enemyZ(i)\posX#), Floor(enemyZ(i)\posY#), enemyZ(i)\frame)
        Else If enemyZ(i)\isBoss = True 
            DrawImage(IMG_ENEMY_BOSS, Floor(enemyZ(i)\posX#), Floor(enemyZ(i)\posY#), enemyZ(i)\frame)
        Else
            DrawImage(IMG_ENEMY, Floor(enemyZ(i)\posX#), Floor(enemyZ(i)\posY#), enemyZ(i)\frame)
        End If 
            
    Next 

End Function
